%  contur1.m
% Matlab file for Part 1 of the Contour Plots and
% Critical Points module

disp('**********************************************')
disp('Part 1: Exploration of a Sample Surface ')
disp('**********************************************')
disp('  ')    

    format short
    
    disp('First enter the function to be investigated:')
    disp(' ')
    disp(' f1=''cos(x-y)*(1-x^2+y)*exp(x*y^2/(1+x^2*y^2))'' ')
    disp(' f = fcnchk(f1,''vectorized'') ')
    disp(' ')
    disp('To continue, type the word return and ')
    disp('hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')

    disp('--------------------------------------------')
    disp('Step 1: ') 
    disp('The commands below define a grid of (x,y) ')
    disp('values and then make a contour plot using')
    disp('15 contour levels for the function f(x,y). ')
    disp(' ')
    disp('Copy the commands below as a group, paste')
    disp('them at a MATLAB prompt, and enter them. ')
    disp(' ')
    disp('  x = linspace(-3,3,50); ')
    disp('  y = linspace(-5,5,50); ')
    disp('  [X,Y] = meshgrid(x,y); ')
    disp('  Z = f(X,Y); ')
    disp('  figure(1); clf ')
    disp('  contour(x,y,Z,15) ')
    disp(' ')
    disp('---------------------------------------------')
    disp('Identify a part of the domain that you think ')
    disp('contains a local maximum or minimum.  What ')
    disp('features of the contour plot indicate a local ')
    disp('maximum or minimum.')
    disp('Answer using MATLAB comments in your diary file.')
    disp(' ')
    disp('To continue, type the word return and ')
    disp('hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')
    
    disp('---------------------------------------------')
    disp('Step 2: ')
    disp('Change the values of a, b, c, and d in order ')
    disp('to ''''zoom in'''' to a selected part of the ')
    disp('contour plot containing a critical point.')  
    disp(' ')
    disp('Set values and then enter: ')
    disp(' ')
    disp('  a=?; b=?;   % Put in x-axis values ')
    disp('  c=?; d=?    % Put in y-axis values ')
    disp(' ')
    disp('  x = linspace(a,b,50); ')
    disp('  y = linspace(c,d,50); ')
    disp('  [X,Y] = meshgrid(x,y); ')
    disp('  Z = f(X,Y); ')
    disp('  figure(2); clf ')
    disp('  contour(x,y,Z,15) ')
    disp(' ')
    disp('------------------------------------------------')
    disp('By zooming closer and closer, find a 2 significant ')
    disp('digit approximation to the coordinates of the ')
    disp('critical point you have chosen. ')
    disp('Give your result using MATLAB comments in your')
    disp('diary file.')
    disp(' ')
    disp('To continue, type the word return and ')
    disp('hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')
    
    disp('------------------------------------------------')
    disp('Step 3 and 4')
    disp('Look at the original contour plot in Figure 1.')
    disp('Identify another region that contains a saddle')
    disp('point.  What features of the contour plot indicates')
    disp('a saddle point. ')
    disp(' ')
    disp('Use the procedure of step 2 to zoom in on the ')
    disp('saddle point you have selected and find its ')
    disp('coordinates to 2SD. ')
    disp(' ')
    disp('Answer questions and give your result using MATLAB')
    disp(' comments in your diary file.')
    disp(' ')
    disp('To continue, type the word return and ')
    disp('hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')
    
    disp('------------------------------------------------')
    disp('Step 5')
    disp('The commands below use MATLAB''s symbolic')
    disp('capabilities to find the partial derivatives ')
    disp('of f(x,y) ')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp(' syms x y')
    disp(' fx = diff(f1, x) ')
    disp(' fy = diff(f1, y) ')
    disp(' ')
    disp('-------------------------------------------------')
    disp('Explain why it looks like it would be very ')
    disp('difficult to solve the equations ')
    disp('     fx = 0 and fy = 0 ')
    disp('for critical points. ')
    disp('Use MATLAB comments in your diary file.')
    disp(' ')
    disp('To continue, type the word return and ')
    disp('hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')

    disp('---------------------------------------------')
    disp('Step 6: ')
    disp('Let''s see if MATLAB can solve these equations.')
    disp(' ')
    disp('Enter:')
    disp(' ')
    disp('  [x,y] = solve(fx, fy, ''x,y'') ')
    disp(' ')
    disp(' ')
    disp('-------------------------------------------- ')
    disp('When you are ready to go on to part 2 ')
    disp('of this module, type: contur2.')
    disp(' ')
