%  contur3.m
% Matlab file for Part 3 of the Contour Plots and
% Critical Points module

disp('**********************************************')
disp('Part 3: Locating the Critical Points ')
disp('**********************************************')
disp('  ')    

    format short
    
    disp('--------------------------------------------')
    disp('Step 1: ') 
    disp('Enter the approximate critical point you  ')
    disp('found that should lead to a maximum or minimum')
    disp('of f.  Then execute the commands that follow ')
    disp('that define the second-degree Taylor polynomial).')
    disp('at the point (x0,y0). ')
    disp(' ')
    disp('Set values and then enter: ')
    disp(' ')
    disp('  x0=?  % Enter the point ')
    disp('  y0=?   ')
    disp(' ')
    disp('  syms x y ')
    disp('  f0=subs(f1,{x,y},{x0,y0}); ')
    disp('  fx0=subs(fx,{x,y},{x0,y0}); ')
    disp('  fy0=subs(fy,{x,y},{x0,y0}); ')
    disp('  L1 = f0 + fx0*(x-x0) + fy0*(y-y0); ')
    disp('  fxx0=subs(fxx,{x,y},{x0,y0}); ')
    disp('  fxy0=subs(fxy,{x,y},{x0,y0}); ')
    disp('  fyy0=subs(fyy,{x,y},{x0,y0}); ')
    disp('  T1 = fxx0*(x-x0)^2; ')
    disp('  T2 = 2*fxy0*(x-x0)*(y-y0); ')
    disp('  T3 = fyy0*(y-y0)^2; ')
    disp('  Q1 = L1 + (1/2)*(T1+T2+T3) ')
    disp(' ')
    disp('To continue, type the word return and ')
    disp('hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')

    disp('------------------------------------------------')
    disp('Step 2:')
    disp('Now take the partials of Q(x,y) and solve the')
    disp('resulting linear system:  Qx=0, Qy=0.  To check ')
    disp('if we are close to a critical point, we evaluate')
    disp('f(x1,y1), fx(x1,y1), and fy(x1,y1) at the solution.')
    disp(' ')
    disp(' ')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  syms x y ')
    disp('  Qx = diff(Q1,x); ')
    disp('  Qy = diff(Q1,y); ')
    disp('  [x1,y1] = solve(Qx,Qy,''x,y'') ');
    disp('  x1=double(x1) ')
    disp('  y1=double(y1) ')
    disp('  f0=subs(f1,{x,y},{x1,y1}) ')
    disp('  fx0=subs(fx,{x,y},{x1,y1}) ')
    disp('  fy0=subs(fy,{x,y},{x1,y1}) ')
    disp(' ')
    disp('To continue, type the word return and ')
    disp('hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')

    disp('-----------------------------------------------')
    disp('Step 3:')
    disp('Go back to step 1 and set x0=x1 and y0=y1, where')
    disp('x1 and y1 are the solution values from step 2. ')
    disp('Re-execute the commands in step 1 to get the ')
    disp('new 2nd-degree Taylor polynomial. ')
    disp(' ')
    disp('To continue, type the word return and ')
    disp('hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')

    disp('-----------------------------------------------')
    disp('Step 3 (cont.): ')
    disp('Now compare the contour plots of f(x,y) ')
    disp('and the latest Taylor approximation Q(x,y). ')
    disp(' ')
    disp('Enter: ')
    disp('  ')
    disp('  delta=0.5 ')
    disp('  x = linspace(x0-delta,x0+delta,50); ')
    disp('  y = linspace(y0-delta,y0+delta,50); ')
    disp('  [X,Y] = meshgrid(x,y); ')
    disp('  Z = f(X,Y); ')
    disp('  Q = fcnchk(char(Q1),''vectorized''); ')
    disp('  W = Q(X,Y); ')
    disp('  figure(1); clf ')
    disp('  contour(x,y,Z,15) ')
    disp('  title(''Contours of f(x,y)'') ')
    disp('  figure(2); clf ')
    disp('  contour(x,y,W,15) ')
    disp('  title(''Contours of Q(x,y)'') ')
    disp(' ')
    disp('-----------------------------------------------')
    disp('What does the comparison of the f(x,y) and ')
    disp('Q(x,y) contour plots tell you? ')
    disp('Discuss using MATLAB comments in your diary file.')
    disp(' ')
    disp('To continue, type the word return and ')
    disp('hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')

    disp('------------------------------------------------')
    disp('Step 4:')
    disp('Repeat the process of steps 2 and 3, solving for')
    disp('the critical point of Q, and then redefining Q.')
    disp('Continue until you have the critical point ')
    disp('determined to 5 significant digits. ')
    disp('  (Note: To see more digits of your answers ')
    disp('   enter ''''format long''''. ')
    disp(' ')
    disp('To continue, type the word return and ')
    disp('hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')

    disp('-----------------------------------------------')
    disp('Step 5:')
    disp('Since we have converged at this stage, the')
    disp('partial derivatives computed for the last ')
    disp('x0, y0 values are sufficiently close to ')
    disp('those for the latest x1, y1 solution. ')
    disp(' ')
    disp('Compute the test values needed for the second ')
    disp('derivative test. ')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp(' test1 = fxx0 ')
    disp(' test2 = fxx0*fyy0 - fxy0^2 ')
    disp(' ')
    disp('-----------------------------------------------')
    disp('What is your conclusion?  Answer using MATLAB')
    disp('comments in your diary file. ')
    disp(' ')
    disp('To continue, type the word return and ')
    disp('hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')

    disp('-----------------------------------------------')
    disp('Step 6:')
    disp('Now, use your estimate of a saddle point from')
    disp('Part 1 as the starting x0, y0 values and')
    disp('iterate on steps 2-4 above to determine the ')
    disp('saddle point to 5SD. ')
    disp(' ')
    disp('-----------------------------------------------')
    disp('Give the coordinates of the saddle point.')
    disp('Use MATLAB comments in your diary file. ')
    disp(' ')
    disp('To continue, type the word return and ')
    disp('hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')

    disp('-----------------------------------------------')
    disp('Step 7')
    disp('Have you in fact located a saddle point?  Explain.')
    disp('Discuss using MATLAB comments in your diary file.')
    disp(' ')
    disp('To continue, type the word return and ')
    disp('hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')
    
    disp('------------------------------------------------')
    disp('Step 8')
    disp('Execute the following commands from Part 1 to')
    disp('repeat your original contour plot of f(x,y). ')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  x = linspace(-3,3,50); ')
    disp('  y = linspace(-5,5,50); ')
    disp('  [X,Y] = meshgrid(x,y); ')
    disp('  Z = f(X,Y); ')
    disp('  figure(1); clf ')
    disp('  contour(x,y,Z,15) ')
    disp(' ')
    disp('-------------------------------------------------')
    disp('Approximate a third critical point in the plot. ')
    disp('It should be a local max if you already have ')
    disp('found a local min and vice versa. ')
    disp(' ')
    disp('As we have done above, use the second degree ')
    disp('successive Taylor approximations to determine ')
    disp('this point to 5SD. ')
    disp(' ')
    disp(' ')
    disp('-------------------------------------------- ')
    disp('When you are ready to go on to part 4 ')
    disp('of this module, type: contur4.')
    disp(' ')
